%set_verify_elf_method relaxed

%def_disable static

%def_with pam
%def_with cbcp
%def_with chapms
%def_with crypt
%def_with mppe
%def_with libatm

Name: ppp
Version: 2.4.4
Release: alt7
Summary: The PPP daemon and documentation
License: distributable
Group: System/Servers
Url: http://www.samba.org/ppp

%add_findprov_lib_path %_libdir/pppd/%version

%define srcname %name-%version
Source0: %srcname.tar.bz2
Source1: %name-2.4.1-sample.tar
Source2: %name.pamd
Source3: ppp-dhcpc.tar.bz2

Patch1: ppp-2.4.4-alt-makefile.patch
Patch2: ppp-2.4.2-alt-pppd-lock.patch
Patch3: ppp-2.4.2-alt-pppd-noresolv.patch
Patch5: ppp-2.4.1-alt-scripts-callback.patch
Patch6: ppp-2.4.2-alt-opts.patch
#Patch7: ppp-2.4.2-asp-cbcp-mps.patch
#Patch8: ppp-2.4.2-asp-radius-chap.patch
Patch9: ppp-20031003-alt-cleardefaultroute.patch
Patch10: ppp-2.4.2-alt-optsigsegv.patch
Patch11: ppp-2.4.4-alt-killmypg.patch
Patch12: ppp-2.4.2-alt-holdoffhack.patch
Patch13: ppp-2.4.4-alt-lib64.patch
Patch14: ppp-2.4.3-includes-sha1.patch
Patch15: ppp-2.4.4-mppe-mppc-1.1.patch
Patch16: ppp-2.4.2-lvu-linkpidfile-backport.patch
Patch17: ppp-2.4.4-lvu-sigterm.patch
Patch18: ppp-2.4.2-alt-leave-ttyperms-alone.patch
Patch19: ppp-2.4.1-varargs.patch
Patch20: ppp-2.4.3-alt-openssl.patch
Patch21: ppp-2.4.4-deb-useopenssl.patch
Patch22: ppp-2.4.4-deb-fixmschapv2.patch
Patch23: ppp-2.4.4-deb-load_ppp_generic_if_needed.patch
Patch24: ppp-2.3.11-suse-oedod.patch
Patch25: ppp-2.4.2-__P.diff
Patch26: ppp-2.4.2-ifname.diff
Patch27: ppp-2.4.2-logwtmp.diff
Patch28: ppp-2.4.2-pie.patch
Patch29: ppp-2.4.2-pppoatm-mtu.patch
Patch30: ppp-2.4.2-smpppd.diff
Patch31: ppp-2.4.3-demand-fix.diff
Patch32: ppp-2.4.3-filter.diff
Patch33: ppp-2.4.3-fixprotoinc.patch
Patch34: ppp-2.4.3-fork-fix.diff
Patch35: ppp-2.4.3-hspeed.patch
Patch36: ppp-2.4.3-ipv6-accept-remote.patch
Patch37: ppp-2.4.3-winbind-setuidfix.patch
Patch38: ppp-2.4.1-pidfile-owner.patch
Patch39: ppp-2.4.2-rp-pppoe-macaddr.patch
Patch40: ppp-2.4.2-rp-pppoe-update.patch
Patch41: pppd-2.4.2-chapms-strip-domain.patch
Patch42: ppp-2.4.4-deb-readable_connerrs.patch
Patch43: ppp-2.4.4-alt-dhcp-makefile.patch
Patch44: ppp-2.4.2-cbcp.patch
Patch45: ppp-2.4.4-cbcp-alt.patch
Patch46: ppp-2.4.4-cbcp-alt-2.patch
Patch47: ppp-2.4.4-cbcp-alt-3.patch
Patch48: ppp-2.4.4-eaptls-mppe-0.9.patch

PreReq: /var/lock/serial
Obsoletes: ppp-cbcp, ppp-mppe
Obsoletes: ppp-extra

BuildRequires: glibc-devel libatm-devel libpam-devel libpcap-devel libssl-devel perl-IPC-Signal perl-Proc-Daemon perl-Proc-WaitStat libcurl-devel
Requires: ppp-common libcurl libssl


%package devel
Summary: Header files needed for building extra pppd plugins
Group: Development/C
Requires: %name = %version-%release

%package radius
Summary: RADIUS authentication plugin for pppd
Group: System/Servers
Requires: %name = %version-%release

%package pppoatm
Summary: PPP over ATM plugin for pppd
Group: System/Servers
Requires: %name = %version-%release


%package pppoe
Summary: PPP over ethernet plugin for pppd
Group: System/Servers
Requires: %name = %version-%release

%package dhcp
Summary: DHCP plugin for %{name}
Group: System/Servers
Requires: %name = %version-%release

%description
The %name package contains the PPP (Point-to-Point Protocol) daemon
and documentation for PPP support.  The PPP protocol provides a
method for transmitting datagrams over serial point-to-point links.

The %name package should be installed if your machine need to support
the PPP protocol.

%description devel
Header files needed for building extra pppd plugins.

%description radius
The Remote Authentication Dial In User Service (RADIUS) plugin for pppd
permits pppd to perform PAP, CHAP, MS-CHAP and MS-CHAPv2 authentication
against a RADIUS server instead of the usual /etc/ppp/pap-secrets and
/etc/ppp/chap-secrets files.

%description pppoatm
PPP over ATM plugin for pppd.

%description pppoe
PPP over ethernet plugin for pppd.

%description    dhcp
DHCP plugin for pppd.


%prep
%setup -q -n %srcname -a1 -a2
pushd pppd/plugins
    tar -xjf %{SOURCE3}
popd

%patch1 -p1
%patch2 -p1
%patch3 -p1
#patch5 -p1
%patch6 -p1
#patch7 -p1
#patch8 -p1
%patch9 -p1
%patch10 -p1
# Conflicts with patch 17 
#patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
#patch15 -p1
# patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p0
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p0
%patch31 -p0
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p0
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p0
%patch45 -p0
%patch46 -p0
%patch47 -p1 
%patch48 -p1 

# enable the dhcp plugin 
perl -p -i -e "s|^(PLUGINS :=)|SUBDIRS += dhcp\n\$1|g" pppd/plugins/Makefile.linux
#set the right paths in radiusclient.conf
sed -i -e "s|/usr/local/etc|%_sysconfdir|" \
	     -e "s|/usr/local/sbin|%_sbindir|" pppd/plugins/radius/etc/radiusclient.conf
#set config dir to /etc/ppp/radius
sed -i -e "s|/etc/radiusclient|/etc/ppp/radius|g" \
		pppd/plugins/radius/{*.8,*.c,*.h} \
		pppd/plugins/radius/etc/*

find -type f -name \*.orig -print -delete

%build
CFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" CXXFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE" %configure
%make_build %{?_with_pam:USE_PAM=y} \
	    %{?_with_cbcp:CBCP=y} \
	    %{?_with_chapms:CHAPMS=y} \
	    %{?_with_crypt:USE_CRYPT=y} \
	    %{?_with_mppe:MPPE=y} \
	    %{?_with_libatm:HAVE_LIBATM=y} \
	    COPTS=" $RPM_OPT_FLAGS -fPIC -Wall -D_GNU_SOURCE -fno-strict-aliasing " \
	    CC="%__cc" \
	    libdir=%_libdir

%install
%make_install install 	DESTDIR=$RPM_BUILD_ROOT \
			BINDIR=$RPM_BUILD_ROOT/%_sbindir \
			INCDIR=$RPM_BUILD_ROOT/%_includedir \
			libdir=%_libdir \
			MANDIR=$RPM_BUILD_ROOT/%_man8dir
%make_install install-etcppp INSTROOT=$RPM_BUILD_ROOT \
			ETCDIR=$RPM_BUILD_ROOT/%_sysconfdir/%name

for f in `find scripts/ sample/ -type f`; do
	chmod 644 "$f"
	if fgrep -qs /usr/local/bin/ "$f"; then
		%__subst -p 's|/usr/local/bin|%_bindir|g' "$f"
	fi
	if file -b "$f" |fgrep -qs 'shell script'; then
		chmod a+x "$f"
	fi
done

%__install -pD -m640 %SOURCE2 $RPM_BUILD_ROOT%_sysconfdir/pam.d/%name

%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/%name/peers
%__install -p -m600 sample/callback-* $RPM_BUILD_ROOT%_sysconfdir/%name/

%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/%name/radius
cp -a pppd/plugins/radius/etc/* $RPM_BUILD_ROOT%_sysconfdir/%name/radius/

%files
%attr(755,root,root) %_sbindir/*
%attr(755,root,root) %dir %_sysconfdir/%name
%attr(711,root,root) %dir %_sysconfdir/%name/peers
%attr(600,root,root) %config(noreplace) %_sysconfdir/%name/*-secrets
%attr(600,root,root) %config(noreplace) %_sysconfdir/%name/eaptls-*
%attr(750,root,root) %config(noreplace) %_sysconfdir/%name/callback-*
%attr(644,root,root) %config(noreplace) %_sysconfdir/%name/options
%config(noreplace) %_sysconfdir/pam.d/%name
%_libdir/pppd
%exclude %_libdir/pppd/%version/pppoatm.so
%exclude %_libdir/pppd/%version/rp-pppoe.so
%exclude %_libdir/pppd/%version/rad*
%exclude %_libdir/pppd/%version/dhcpc.so
%_man8dir/*.8*
%exclude %_man8dir/*rad*
%doc PLUGINS SETUP FAQ README* scripts sample

%files devel
%_includedir/pppd

%files pppoatm
%_libdir/pppd/%version/pppoatm.so

%files pppoe
%_libdir/pppd/%version/rp-pppoe.so
%attr(755,root,root) %_sbindir/pppoe-discovery

%files radius
%_libdir/pppd/%version/rad*.so
%_man8dir/*rad*
%config(noreplace) %_sysconfdir/%name/radius/

%files dhcp
%doc pppd/plugins/dhcp/README
%doc pppd/plugins/dhcp/AUTHORS
%doc pppd/plugins/dhcp/COPYING
%_libdir/pppd/%version/dhcpc.so

%changelog
* Tue Aug 07 2007 Denis Smirnov <mithraen@altlinux.ru> 2.4.4-alt7
- Rebuild

* Tue Aug 07 2007 Vladimir V Kamarzin <vvk@altlinux.ru> 2.4.4-alt6
- Install cbcp.h (Closes: #12368)

* Mon Jun 25 2007 Denis Smirnov <mithraen@altlinux.ru> 2.4.4-alt5
- Add eaptls support (Michael A. Kangin)

* Sat May 12 2007 Denis Smirnov <mithraen@altlinux.ru> 2.4.4-alt4
- Patch for CBCP patch. Now CBCP server works and always accepts "no callback"
  users (hiddenman@)
- Fixed CBCP patch by patch46. It shouldn't break chat now (hiddenman@)
- Build without patch15 (mppe+mppc) (hiddenman@)
- Completely disable commented patches (hiddenman@)

* Sun Apr 29 2007 Denis Smirnov <mithraen@altlinux.ru> 2.4.4-alt3
- Add reworked by Andrew Kornilov CBCP patch from ASP Linux (disabled)
- More correct mppe+mppc patch (by Andrew Kornilov)

* Sun Apr 08 2007 Denis Smirnov <mithraen@altlinux.ru> 2.4.4-alt2
- Add requires to ppp-common (#11382)

* Sun Mar 25 2007 Denis Smirnov <mithraen@altlinux.ru> 2.4.4-alt1
- Build 2.4.4 for Sisyphus

* Mon Mar 19 2007 Alexey Shabalin <shaba@altlinux.ru> 2.4.4-alt0.1
- 2.4.4 (Sorry - normal changelog after ...)
- fix for #11110 (cbcp)

* Sun Oct 15 2006 Denis Smirnov <mithraen@altlinux.ru> 2.4.2-alt7 
- Create linkpidfile when start pppd, not when connected (Valentin Lavrinenko)
- do not ignore SIGTERM before chat started (Valentin Lavrinenko)

* Thu Jan 12 2006 ALT QA Team Robot <qa-robot@altlinux.org> 2.4.2-alt6.1.1
- Rebuilt for new style PAM dependencies generated by rpm-build-4.0.4-alt55.

* Sat Nov 05 2005 LAKostis <lakostis at altlinux.ru> 2.4.2-alt6.1
- add missing requires for libradiusclient-devel.
- disable -static build by default.

* Wed Mar 23 2005 Kachalov Anton <mouse@altlinux.ru> 2.4.2-alt6
- enable Radius plugin

* Fri Mar 18 2005 Kachalov Anton <mouse@altlinux.ru> 2.4.2-alt5
- disable MPPE/MPPC patch
- disable Radius plugin

* Sun Feb 13 2005 Kachalov Anton <mouse@altlinux.ru> 2.4.2-alt4
- added MPPE/MPPC support: by default, it's disabled

* Thu Feb 10 2005 Kachalov Anton <mouse@altlinux.ru> 2.4.2-alt3
- x86_64 support (#6088)

* Tue Jun 08 2004 Alexey Voinov <voins@altlinux.ru> 2.4.2-alt2
- killmypg added. [fixes some race conditions in signal handlers]
- holdoffhack added [fix for #1589]

* Fri May 28 2004 Alexey Voinov <voins@altlinux.ru> 2.4.2-alt1
- new version (2.4.2)
- patches updated [note: README.cbcp from asp path has been dropped :(]
- asp-radius-chap patch has been merged into upstream
- optsigsegv patch added [fix for #1158]
- buildreqs updated

* Wed Dec 03 2003 Dmitry V. Levin <ldv@altlinux.org> 2.4.1.20031003-alt2
- Implemented cleardefaultroute option (#3319).
- Do not package .la files.

* Wed Nov 12 2003 Dmitry V. Levin <ldv@altlinux.org> 2.4.1.20031003-alt1
- Updated to cvs snapshot 20031003.
- Build the radius plugin with libradiusclient dynamically,
  to avoid text relocations.
- Fixed the radius plugin to use new chap auth (ASP Linux).

* Wed Oct 08 2003 Dmitry V. Levin <ldv@altlinux.org> 2.4.1.20030923-alt1
- Updated to cvs snapshot 20030923.
- ppp-extra: fixed package dependencies.

* Tue Oct 07 2003 Victor V Ismakaev <ivv@altlinux.ru> 2.4.1.20030513-alt3
- Build with radius support.
- Added experimental CBCP support (ASP Linux) and enabled it by default.

* Thu Jul 17 2003 Alexey Voinov <voins@altlinux.ru> 2.4.1.20030513-alt2
- fixed permissions for /etc/ppp/peers to 711
- added opts patch (noauth and noipdefault into /etc/ppp/options)

* Sat May 24 2003 Dmitry V. Levin <ldv@altlinux.org> 2.4.1.20030513-alt1
- Updated to 2.4.2b3+ (snapshot 20030513).
- Rediffed patches, only five of them left.
- Packaged plugins.
- PAM configuration policy enforcement.
- Dropped pppgetpass.
- Packaged ppp-radius and radiusclient libraries (not enabled by default).

* Thu Oct 24 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt8
- Rebuilt in new environment
- Changed pppd URL
- Changed version string
- Added devel package - it contains headers from pppd

* Tue May 22 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt7
- Removed requires to glibc & pam & kernel - now it's bad requires...

* Mon Jan 21 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt6
- Fixed permissions on %_sysconfdir/%name/callback-* - now it's 750.
- Fixed patch5 - atdt->atdp

* Wed Jan 16 2002 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt5
- Removed MPPE & CBCP builddefs - now these features compiled in standart
  CBCP package
- Added some patches from ASP Linux

* Tue Oct 16 2001 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt4
- Changes to new /var/lock/serial scheme

* Fri Aug 03 2001 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt3.2
- Added MPPE support

* Thu Aug 02 2001 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt3.1
- Some fixes to CBCP patch
- Added DEBUG_CBCP define
- Fixed spec file

* Wed Jul 04 2001 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt3
- Fixed CBCP debug messages
- Added option to BUILD_CBCP
- Placed CBCP configs in right place
- Updated CBCP from Bolke de Bruin release
- Added noresolv patch
- Some spec cleanup
- Added pppgetpass program from contrib

* Thu Jun 14 2001 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt2
- Fixed CBCP_SUPPORT in Makefile

* Mon May 28 2001 Konstantin Volckov <goldhead@altlinux.ru> 2.4.1-alt1
- Updated 2 new version
- Fixed cbcp compiling

* Fri Oct 13 2000 Dmitry V. Levin <ldv@fandra.org> 2.4.0-ipl2mdk
- Updated pam configuration.

* Wed Aug  8 2000 Dmitry V. Levin <ldv@fandra.org> 2.4.0-ipl1mdk
- Updated to 2.4.0.

* Thu Jul 13 2000 Dmitry V. Levin <ldv@fandra.org> 2.4.0b2-ipl1mdk
- Updated to 2.4.0b2.
- Patched samples to avoid unnecessary dependencies.
- Added zlib patch from James Carlson <james.d.carlson@east.sun.com>
  (see ftp://playground.sun.com/pub/carlsonj/zlib-bug.notes for details).
- Moved scripts and samples to separate package to split dependencies.

* Mon Apr 03 2000 Dmitry V. Levin <ldv@fandra.org>
- Added: noresolvconf option support.

* Thu Mar 09 2000 Dmitry V. Levin <ldv@fandra.org>
- Fixed check for pam_open_session result code
  (by Leon Kanter <leon@blackcatlinux.com>).
- Merge with Mandrake.

* Sun Jan 02 2000 Dmitry V. Levin <ldv@fandra.org>
- 2.3.11

* Thu Nov 11 1999 Dmitry V. Levin <ldv@fandra.org>
- Merge with RH.

* Sun Oct 17 1999 Dmitry V. Levin <ldv@fandra.org>
- Fandra adaptions.

* Mon Sep 20 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Fix %%post ??

* Mon Sep 20 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Fix %%post

* Mon Sep 20 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- -DCHAPMS
- -DUSE_PAM

* Tue Sep  7 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Add /dev/ppp
- Add entries in /etc/conf.modules if they aren't there yet

* Wed Aug 25 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 2.3.9 (required for kernel 2.3.14+)

* Thu Jul 15 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Removing unused stuff.
- Upgrade patch.
- 2.3.8.

* Fri Jul 10 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Define the .pid to /var/run/
- Glare @Chmouel

* Fri Jul 09 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Define the .pid to /var/run not to /etc/ (reported by Nikodemus Karlsson
  <nickek@algonet.se>).

* Wed May 05 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.com>
- Mandrake adaptions
- handle RPM_OPT_FLAGS

* Fri Apr 09 1999 Cristian Gafton <gafton@redhat.com>
- force pppd use the glibc's logwtmp instead of implementing its own

* Wed Apr 01 1999 Preston Brown <pbrown@redhat.com>
- version 2.3.7 bugfix release

* Tue Mar 23 1999 Cristian Gafton <gafton@redhat.com>
- version 2.3.6

* Mon Mar 22 1999 Michael Johnson <johnsonm@redhat.com>
- auth patch

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com>
- auto rebuild in the new build environment (release 3)

* Thu Jan 07 1999 Cristian Gafton <gafton@redhat.com>
- build for glibc 2.1

* Fri Jun  5 1998 Jeff Johnson <jbj@redhat.com>
- updated to 2.3.5.

* Tue May 19 1998 Prospector System <bugs@redhat.com>
- translations modified for de

* Fri May  8 1998 Jakub Jelinek <jj@ultra.linux.cz>
- make it run with kernels 2.1.100 and above.

* Fri Apr 24 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Mar 18 1998 Cristian Gafton <gafton@redhat.com>
- requires glibc 2.0.6 or later

* Wed Mar 18 1998 Michael K. Johnson <johnsonm@redhat.com>
- updated PAM patch to not turn off wtmp/utmp/syslog logging.

* Wed Jan  7 1998 Cristian Gafton <gafton@redhat.com>
- added the /etc/pam.d config file
- updated PAM patch to include session support

* Tue Jan  6 1998 Cristian Gafton <gafton@redhat.com>
- updated to %name-2.3.3, build against glibc-2.0.6 - previous patches not
  required any more.
- added buildroot
- fixed the PAM support, which was really, completely broken and against any
  standards (session support is still not here... :-( )
- we build against running kernel and pray that it will work
- added a samples patch; updated glibc patch

* Thu Dec 18 1997 Erik Troan <ewt@redhat.com>
- added a patch to use our own route.h, rather then glibc's (which has
  alignment problems on Alpha's) -- I only applied this patch on the Alpha,
  though it should be safe everywhere

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- turned off the execute bit for scripts in %prefix/doc

* Fri Jul 18 1997 Erik Troan <ewt@redhat.com>
- built against glibc

* Tue Mar 25 1997 Erik Troan <ewt@redhat.com>
- Integrated new patch from David Mosberger
- Improved description
